%{!?lua_version: %global lua_version %{lua: print(string.sub(_VERSION, 5))}}
%{!?lua_libdir: %global lua_libdir %{_libdir}/lua/%{lua_version}}
%{!?lua_pkgdir: %global lua_pkgdir %{_datadir}/lua/%{lua_version}}

%{!?lua_compat_version: %global lua_compat_version 5.1}
%{!?lua_compat_libdir: %global lua_compat_libdir %{_libdir}/lua/%{lua_compat_version}}
%{!?lua_compat_pkgdir: %global lua_compat_pkgdir %{_datadir}/lua/%{lua_compat_version}}
%{!?lua_compat_builddir: %global lua_compat_builddir %{_builddir}/compat-lua-%{name}-%{version}-%{release}}

Summary:        Network support for the Lua language
Name:           lua-socket
Version:        3.1.0
Release:    2%{?dist}
License:        MIT
URL:            https://lunarmodules.github.io/luasocket/
Source0:        https://github.com/lunarmodules/luasocket/archive/v%{version}/luasocket-%{version}.tar.gz
Requires:       lua(abi) = %{lua_version}
BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  lua >= %{lua_version}
BuildRequires:  lua-devel >= %{lua_version}

%description
LuaSocket is a Lua extension library that is composed by two parts: The C
core that provides support for the TCP and UDP transport layers, and the
set of Lua modules that add support for functionality commonly needed by
applications that deal with the Internet.

Among the support modules, the most commonly used implement the SMTP, HTTP
and FTP. In addition there are modules for MIME, URL handling and LTN12.

%package -n lua%{lua_compat_version}-socket
Summary:        Network support for the Lua %{lua_compat_version} language
Provides:       lua-socket-compat = %{version}-%{release}
Provides:       lua-socket-compat = %{version}-%{release}
Requires:       lua(abi) = %{lua_compat_version}
BuildRequires:  compat-lua >= %{lua_compat_version}
BuildRequires:  compat-lua-devel >= %{lua_compat_version}

%description -n lua%{lua_compat_version}-socket
LuaSocket is a Lua %{lua_compat_version} extension library that is composed by two parts: The
C core that provides support for the TCP and UDP transport layers, and the
set of Lua %{lua_compat_version} modules that add support for functionality commonly needed by
applications that deal with the Internet.

Among the support modules, the most commonly used implement the SMTP, HTTP
and FTP. In addition there are modules for MIME, URL handling and LTN12.

%prep
%setup -q -n luasocket-%{version}

rm -rf %{lua_compat_builddir}
cp -a . %{lua_compat_builddir}

%build
%make_build linux \
  LUAV=%{lua_version} \
  CFLAGS_linux="$RPM_OPT_FLAGS -fPIC -I%{_includedir} -DLUASOCKET_NODEBUG -DLUA_COMPAT_APIINTCASTS" \
  LDFLAGS_linux="$RPM_LD_FLAGS -shared -o "

pushd %{lua_compat_builddir}
%make_build linux \
  LUAV=%{lua_compat_version} \
  CFLAGS_linux="$RPM_OPT_FLAGS -fPIC -I%{_includedir}/lua-%{lua_compat_version} -DLUASOCKET_NODEBUG -DLUA_COMPAT_APIINTCASTS" \
  LDFLAGS_linux="$RPM_LD_FLAGS -shared -o "
popd

%install
make install-unix INSTALL_DATA='install -p -m 644' \
  INSTALL_TOP=%{buildroot} \
  INSTALL_TOP_CDIR=%{buildroot}%{lua_libdir} \
  INSTALL_TOP_LDIR=%{buildroot}%{lua_pkgdir}

pushd %{lua_compat_builddir}
make install-unix INSTALL_DATA='install -p -m 644' \
  INSTALL_TOP=%{buildroot} \
  INSTALL_TOP_CDIR=%{buildroot}%{lua_compat_libdir} \
  INSTALL_TOP_LDIR=%{buildroot}%{lua_compat_pkgdir}
popd

%check
lua -e \
  'package.cpath="%{buildroot}%{lua_libdir}/?.so;"..package.cpath;
   package.path="%{buildroot}%{lua_pkgdir}/?.lua;"..package.path;
   dofile("test/hello.lua");'

lua-%{lua_compat_version} -e \
  'package.cpath="%{buildroot}%{lua_compat_libdir}/?.so;"..package.cpath;
   package.path="%{buildroot}%{lua_compat_pkgdir}/?.lua;"..package.path;
   dofile("test/hello.lua");'

%files
%license LICENSE
%doc CHANGELOG.md README.md docs/*.html docs/*.css docs/*.png
%{lua_libdir}/mime/
%{lua_libdir}/socket/
%{lua_pkgdir}/*.lua
%{lua_pkgdir}/socket/

%files -n lua%{lua_compat_version}-socket
%license LICENSE
%doc CHANGELOG.md README.md docs/*.html docs/*.css docs/*.png
%{lua_compat_libdir}/mime/
%{lua_compat_libdir}/socket/
%{lua_compat_pkgdir}/*.lua
%{lua_compat_pkgdir}/socket/

%changelog
* Wed May 08 2024 Fanjun Kong <fanjunkong@tencent.com> - 3.1.0-2
- epol debrand

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.1.0-1
- initial build
